<?php

namespace App\Providers;


use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Providers\RoutesProvider\RoutesRunnable;

class RouteServiceProvider extends ServiceProvider
{
    /**
     * This namespace is applied to your controller routes.
     *
     * In addition, it is set as the URL generator's root namespace.
     *
     * @var string
     */
    protected $namespace = 'App\Http\Controllers';

    /**
     * The path to the "home" route for your application.
     *
     * @var string
     */
    public const HOME = '/home';

    /**
     * Define your route model bindings, pattern filters, etc.
     *
     * @return void
     */
    public function boot()
    {
        //
//
        parent::boot();
//        $this->routes(function () {
//            RoutesRunnable::run();
//        });
    }



    /**
     * Define the routes for the application.
     *
     * @return void
     */
    public function map()
    {
        $this->mapApiRoutes();
        $this->mapWebRoutes();

        //
    }

    /**
     * Define the "web" routes for the application.
     *
     * These routes all receive session state, CSRF protection, etc.
     *
     * @return void
     */
    protected function mapWebRoutes()
    {
        Route::middleware('web')
            ->namespace($this->namespace)
            ->group(base_path('routes/web.php'));
    }

    /**
     * Define the "api" routes for the application.
     *
     * These routes are typically stateless.
     *
     * @return void
     */
    protected function mapApiRoutes()
    {
        $namespace="App\Http\Controllers\Api";
        Route::group(["prefix" => "api/{lang}/", "middleware" => ["api","lang"] , "namespace" => $namespace, "name" => "api."],function() use ($namespace){
            Route::namespace("Auth")->group(base_path('routes/api/auth.php'));

            //Group Has Auth
            Route::middleware("auth:api")->group(function (){
                Route::group([],base_path('routes/api/main/with_authentication.php'));
                Route::group([],base_path('routes/api/client/with_authentication.php'));
//                Route::group(["middleware" => "is-technician"],base_path('routes/api/technician/with_authentication.php'));
            });

            //Group Hasn't Auth
            Route::group([],base_path('routes/api/main/without_authentication.php'));
            Route::group([],base_path('routes/api/client/without_authentication.php'));

        });

    }
}

